=item register
-Register an existing repository in the mrconfig file. By default, the
+Register an existing repository in a mrconfig file. By default, the
repository in the current directory is registered, or you can specify a
directory to register.
-By default it registers it to the ~/.mrconfig file. To make it write to a
-different file, use the -c option.
+The mrconfig file that is modified is chosen by either the -c option, or by
+looking for the closest known one at or below the current directory.
=item config
-Adds, modifies, removes, or prints a value from the mrconfig file. The next
+Adds, modifies, removes, or prints a value from a mrconfig file. The next
parameter is the name of the section the value is in. To add or modify
values, use one or more instances of "parameter=value". Use "parameter=" to
remove a parameter. Use just "parameter" to get the value of a parameter.
mr config src/foo update
+The ~/.mrconfig file is used by default. To use a different config file,
+use the -c option.
+
=item help
Displays this help.
=item -c mrconfig
-Use the specified mrconfig file, instead of looking for one in your home
-directory.
+Use the specified mrconfig file. The default is B<~/.mrconfig>
=item -v
Expand the statistics line displayed at the end to include information
about exactly which repositories failed and were skipped, if any.
+=item -n
+
+Just operate on the repository for the current directory, do not
+recurse into deeper repositories.
+
=back
=head1 FILES
"$@". The "checkout" command is run in the parent of the repository
directory, since the repository isn't checked out yet. All other commands
are run inside the repository, though not necessarily at the top of it.
+
The "MR_REPO" environment variable is set to the path to the top of the
-repository, and "MR_CONFIG" is set to the topmost .mrconfig file used.
+repository. The "MR_CONFIG" environment variable is set to the .mrconfig file
+that defines the repo being acted on, or, if the repo is not yet in a config
+file, the .mrconfig file that should be modified to register the repo.
A few parameters have special meanings:
=item skip
-If the "skip" parameter is set and its command returns nonzero, then B<mr>
+If the "skip" parameter is set and its command returns true, then B<mr>
will skip acting on that repository. The command is passed the action
name in $1.
=item chain
-If the "chain" parameter is set and its command returns nonzero, then B<mr>
+If the "chain" parameter is set and its command returns true, then B<mr>
will try to load a .mrconfig file from the root of the repository. (You
should avoid chaining from repositories with untrusted committers.)
=item deleted
-If the "deleted" parameter is set and its command returns nonzero, then
+If the "deleted" parameter is set and its command returns true, then
B<mr> will treat the repository as deleted. It won't ever actually delete
the repository, but it will warn if it sees the repository's directory.
This is useful when one mrconfig file is shared amoung multiple machines,
};
$ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
+my $config_overridden=0;
my $directory=getcwd();
my $verbose=0;
my $stats=0;
+my $no_recurse=0;
my %config;
+my %configfiles;
my %knownactions;
my %alias;
Getopt::Long::Configure("no_permute");
my $result=GetOptions(
"d|directory=s" => sub { $directory=abs_path($_[1]) },
- "c|config=s" => sub { $ENV{MR_CONFIG}=abs_path($_[1]) },
+ "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
"v|verbose" => \$verbose,
"s|stats" => \$stats,
+ "n|no-recurse" => \$no_recurse,
);
if (! $result || @ARGV < 1) {
die("Usage: mr [-d directory] action [params ...]\n".
}
+# Make sure MR_CONFIG is an absolute path, but don't use abs_path since
+# the config file might be a symlink to elsewhere, and the directory it's
+# in is significant.
+if ($ENV{MR_CONFIG} !~ /^\//) {
+ $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
+}
+
loadconfig(\*DATA);
loadconfig($ENV{MR_CONFIG});
#use Data::Dumper;
}
}
+# commands that do not operate on all repos
if ($action eq 'help') {
exec($config{''}{DEFAULT}{$action}) || die "exec: $!";
}
}
my $section=shift;
if ($section=~/^\//) {
- # try to convert to a path relative to $config's dir
+ # try to convert to a path relative to the config file
my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
+ $dir=abs_path($dir);
+ $dir.="/" unless $dir=~/\/$/;
if ($section=~/^\Q$dir\E(.*)/) {
$section=$1;
}
exit 0;
}
elsif ($action eq 'register') {
+ if (! $config_overridden) {
+ # Find the closest known mrconfig file to the current
+ # directory.
+ $directory.="/" unless $directory=~/\/$/;
+ foreach my $topdir (reverse sort keys %config) {
+ next unless length $topdir;
+ if ($directory=~/^\Q$topdir\E/) {
+ $ENV{MR_CONFIG}=$configfiles{$topdir};
+ last;
+ }
+ }
+ }
my $command="set -e; ".$config{''}{DEFAULT}{lib}."\n".
"my_action(){ $config{''}{DEFAULT}{$action}\n }; my_action ".
join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
my $d=$directory;
$dir.="/" unless $dir=~/\/$/;
$d.="/" unless $d=~/\/$/;
- next if $dir ne $directory && $dir !~ /^\Q$directory\E/;
+ next if $no_recurse && $d ne $dir;
+ next if $dir ne $d && $dir !~ /^\Q$d\E/;
push @repos, [$dir, $topdir, $subdir];
}
}
sub action { #{{{
my ($action, $dir, $topdir, $subdir) = @_;
-
- my $lib= exists $config{$topdir}{$subdir}{lib} ?
- $config{$topdir}{$subdir}{lib}."\n" : "";
+
+ $ENV{MR_CONFIG}=$configfiles{$topdir};
+ my $lib=exists $config{$topdir}{$subdir}{lib} ?
+ $config{$topdir}{$subdir}{lib}."\n" : "";
if (exists $config{$topdir}{$subdir}{deleted}) {
- if (! -d $dir) {
- return;
+ my $test="set -e;".$lib.$config{$topdir}{$subdir}{deleted};
+ print "mr $action: running deleted test >>$test<<\n" if $verbose;
+ my $ret=system($test);
+ if ($ret != 0) {
+ if (($? & 127) == 2) {
+ print STDERR "mr $action: interrupted\n";
+ exit 2;
+ }
+ elsif ($? & 127) {
+ print STDERR "mr $action: deleted test received signal ".($? & 127)."\n";
+ }
}
- else {
- my $test="set -e;".$lib.$config{$topdir}{$subdir}{deleted};
- print "mr $action: running deleted test >>$test<<\n" if $verbose;
- my $ret=system($test);
- if ($ret != 0) {
- if (($? & 127) == 2) {
- print STDERR "mr $action: interrupted\n";
- exit 2;
- }
- elsif ($? & 127) {
- print STDERR "mr $action: deleted test received signal ".($? & 127)."\n";
- }
- if ($ret >> 8 == 0) {
- print STDERR "mr error: $dir should be deleted yet still exists\n\n";
- push @failed, $dir;
- return;
- }
+ if ($ret >> 8 == 0) {
+ if (-d $dir) {
+ print STDERR "mr error: $dir should be deleted yet still exists\n\n";
+ push @failed, $dir;
+ return;
+ }
+ else {
+ print "mr $action: $dir skipped (as deleted) per config file\n" if $verbose;
+ push @skipped, $dir;
+ return;
}
}
}
print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
exit 1;
}
- if ($ret >> 8 == 0) {
- print "mr $action: $dir skipped per config file\n" if $verbose;
- push @skipped, $dir;
- return;
- }
+ }
+ if ($ret >> 8 == 0) {
+ print "mr $action: $dir skipped per config file\n" if $verbose;
+ push @skipped, $dir;
+ return;
}
}
print "mr $action: (skipped: ".join(" ", @skipped).")\n";
}
if (@failed) {
- print "mr $action: (failed: ".join(" ", @failed).")\n";
+ print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
}
}
if (@failed) {
$dir=".";
}
$dir=abs_path($dir)."/";
+
+ if (! exists $configfiles{$dir}) {
+ $configfiles{$dir}=$f;
+ }
# copy in defaults from first parent
my $parent=$dir;
if [ -z "$url" ]; then
error "cannot determine svn url"
fi
- echo "Registering svn url: $url"
+ echo "Registering svn url: $url in $MR_CONFIG"
mr -c "$MR_CONFIG" config "$(pwd)" checkout="svn co $url $basedir"
elif [ -d .git ]; then
url=$(LANG=C git-config --get remote.origin.url)
if [ -z "$url" ]; then
error "cannot determine git url"
fi
- echo "Registering git url: $url"
+ echo "Registering git url: $url in $MR_CONFIG"
mr -c "$MR_CONFIG" config "$(pwd)" checkout="git clone $url $basedir"
elif [ -d .bzr ]; then
url=$(cat .bzr/branch/parent)
if [ -z "$url" ]; then
error "cannot determine bzr url"
fi
- echo "Registering bzr url: $url"
+ echo "Registering bzr url: $url in $MR_CONFIG"
mr -c "$MR_CONFIG" config "$(pwd)" checkout="bzr clone $url $basedir"
+ elif [ -d CVS ]; then
+ repo=$(cat CVS/Repository)
+ root=$(cat CVS/Root)
+ if [ -z "$root" ]; then
+ error "cannot determine cvs root"
+ fi
+ echo "Registering cvs repository $repo at root $root"
+ mr -c "$MR_CONFIG" config "$(pwd)" \
+ checkout="cvs -d '$root' co -d $basedir $repo"
else
error "unable to register this repo type"
fi